const std = @import("std");
const Db = @import("Db.zig");

const Item = @import("Item.zig");
const Tag = @import("Tag.zig");
const json = @import("json.zig");
const request = @import("request.zig");

pub fn main() !void {

    var db = Db.open("test.tkh", true, "");

    // ---------------------- ADD ---------------------------

    const jsonText: [:0]const u8 =
        \\{ "add" : [
        \\    [
        \\        "task:uned:led",
        \\        "fur:dusk",
        \\        "made_with:krita",
        \\        "date:2022:10:01",
        \\        "alunya"
        \\    ],[
        \\        "fur:lara",
        \\        "made_with:krita",
        \\        "date:2022:04:08",
        \\        "cell-shading"
        \\    ],[
        \\        "made_with:ballpoint_pen",
        \\        "date:2022:11:04",
        \\        "practice",
        \\        "pose_practice"
        \\    ],[
        \\        "fur:lidiarock1",
        \\        "made_with:krita",
        \\        "date:2022:10:15",
        \\        "niko_(oneshot)"
        \\    ]
        \\] }
    ;

    var jobj = json.Obj.newFromString(jsonText);
    defer jobj.deinit();

    try request.process(&jobj, &db);

    std.debug.print("\n\n", .{});

    // -------------------- DELETE --------------------------

    const jsonDelete: [:0]const u8 =
        \\{ "delete" : [ "0000", "0003" ] }
    ;

    var jdelete = json.Obj.newFromString(jsonDelete);
    defer jdelete.deinit();

    try request.process(&jdelete, &db);

    // -------------------- QUERY ---------------------------

    const jsonQuery: [:0]const u8 =
        \\{ "query" : "fur made_with:krita date:2022", "limit" : 20 }
    ;

    var jquery = json.Obj.newFromString(jsonQuery);
    defer jquery.deinit();

    try request.process(&jquery, &db);
}
